/*****
*
*   BitWriterLSB.js
*
*   copyright 2003, Kevin Lindsey
*   licensing info available at: http://www.kevlindev.com/license.txt
*
*****/

/*****
*
*   class variables
*
*****/
BitWriterLSB.VERSION = 1.0;


/*****
*
*   constructor
*
*****/
function BitWriterLSB() {
    this.data = [];
    this.mask = 0x01;
    this.currentByte = null;
}


/*****
*
*   writeBit
*
*****/
BitWriterLSB.prototype.writeBit = function(value) {
    if ( value ) this.currentByte |= this.mask;

    this.mask <<= 1;
    if ( this.mask == 0x100 ) {
        this.data.push(this.currentByte);
        this.currentByte = 0;
        this.mask = 0x01;
    }
};


/*****
*
*   writeBits
*
*****/
BitWriterLSB.prototype.writeBits = function(value, bitCount) {
    var end = 1 << bitCount;

    for ( var  mask = 1; mask != end; mask <<= 1 ) {
        this.writeBit( (value&mask) ? 1: 0 );
    }
};


/*****
*
*   close
*
*****/
BitWriterLSB.prototype.close = function() {
    if ( this.mask != 0x01 ) {
        this.data.push(this.currentByte);
    }
};

