/*****
*
*   BitWriterMSB.js
*
*   copyright 2003, Kevin Lindsey
*   licensing info available at: http://www.kevlindev.com/license.txt
*
*****/

/*****
*
*   class variables
*
*****/
BitWriterMSB.VERSION = 1.0;


/*****
*
*   constructor
*
*****/
function BitWriterMSB() {
    this.data = [];
    this.mask = 0x80;
    this.currentByte = null;
}


/*****
*
*   writeBit
*
*****/
BitWriterMSB.prototype.writeBit = function(value) {
    if ( value ) this.currentByte |= this.mask;

    this.mask >>= 1;
    if ( this.mask == 0 ) {
        this.data.push(this.currentByte);
        this.currentByte = 0;
        this.mask = 0x80;
    }
};


/*****
*
*   writeBits
*
*****/
BitWriterMSB.prototype.writeBits = function(value, bitCount) {
    var mask = 1 << (bitCount - 1);

    while ( mask != 0 ) {
        this.writeBit( (value&mask) ? 1: 0 );
        mask >>= 1;
    }
};


/*****
*
*   close
*
*****/
BitWriterMSB.prototype.close = function() {
    if ( this.mask != 0x80 ) {
        this.data.push(this.currentByte);
    }
};

